﻿using System.Collections.Generic;
using TSLab.Script;
using TSLab.Script.Handlers;
using TSLab.DataSource;
using TSLab.Script.Helpers;

namespace FractalSimpleHigh
{
	public class Fractal_S_high : IBar2DoubleHandler, IContextUses
	{
		[HandlerParameter]
		public int Period { get; set; }
		
		public IList<double> Execute(ISecurity source)
		{
		     var high = Context.GetData("Highest", new[] { Period.ToString() },
		                               () => Series.Highest(source.HighPrices, Period));
		    var low = Context.GetData("Lowest", new[] { Period.ToString() },
		                               () => Series.Lowest(source.LowPrices, Period));
		    var closes = source.ClosePrices;
		    double fr=0;
		    
		    IList<double> list = new List<double>(closes.Count);
		    list.Add(0);
		    
		    for (int i = Period+4; i < closes.Count; i++)
		    {
		    	if((high[i-2] >= high[i-4]) && (high[i-2] >= high[i-3]) && (high[i-2] >= high[i-1]) && (high[i-2] > high[i]))
		    	{
		    	 fr = high[i-2] ;
		    		
		    	}
		        list.Add(fr);
		    }
		    return list;
		}
		
		public IContext Context { get; set; }
	}
}

